EAPI="3"

WANT_AUTOMAKE="latest"
WANT_AUTOCONF="latest"

inherit eutils versionator

case ${PV} in
  *_pre*)
    MY_P=${PN}-$(replace_version_separator 2 '-')
  ;;
  *)
    MY_P=${PN}-${PV}
  ;;
esac

if [ ${PV} = "9999" ]; then
  inherit subversion autotools
  ESVN_REPO_URI="https://catsfoot.svn.sourceforge.net/svnroot/catsfoot/trunk"
  ESVN_BOOTSTRAP="./bootstrap"
  DOXYGENDEP="doc? ( app-doc/doxygen )"
  S="${WORKDIR}/${P}"
else
  KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~x86-fbsd"
  case ${PV} in
    *_pre*)
    SRC_URI="http://${PN}.sourceforge.net/nightly/${MY_P}.tar.xz"
    ;;
    *)
    SRC_URI="mirror://sourceforge/${PN}/${MY_P}.tar.xz"
    ;;
  esac
  S="${WORKDIR}/${MY_P}"
fi

DESCRIPTION="Catsfoot provides axiom testing for C++11."
HOMEPAGE="http://catsfoot.sf.net/"

LICENSE="GPL-3"

SLOT="0"
IUSE="doc"

RDEPEND=">=sys-devel/gcc-4.5.1
	${DOXYGENDEP}"
DEPEND="${RDEPEND}"

src_configure() {
    econf --docdir=/usr/share/doc/"${PF}" || die
}

src_compile() {
    emake || die
}

src_install() {
    emake DESTDIR="${D}" install || die
    dodoc ChangeLog
    if use doc; then
      emake DESTDIR="${D}" install-html || die
    fi
}

src_test() {
  emake distcheck
}
