// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef POSITION_HH
# define POSITION_HH

namespace catsfoot {
  namespace details {

    /// \brief Finds the first occurrence of a type in a list
    template <size_t, typename, typename...>
    struct position_impl {};

    /// \brief Finds the first occurrence of a type in a list
    template <size_t N, typename T, typename... U>
    struct position_impl<N, T, T, U...>:
      public std::integral_constant<size_t, N> {
    };

    /// \brief Finds the first occurrence of a type in a list
    template <size_t N, typename T, typename U, typename... V>
    struct position_impl<N, T, U, V...>:
      public position_impl<N+1, T, V...> {
    };

    /// \brief Finds the first occurrence of a type in a list
    template <typename T, typename... U>
    struct position: public position_impl<0u, T, U...> {
    };
  }
}

#endif
