// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ALWAYS_FALSE_HH
# define ALWAYS_FALSE_HH

# include <type_traits>

namespace catsfoot {

  namespace details {
    /// \brief Predicate always false but depending on type parameters
    template <typename... T>
    struct always_false: public std::false_type {
    };

    /// \brief Predicate always true but depending on type parameters
    template <typename... T>
    struct always_true: public std::true_type {
    };
  }

}

#endif
