// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

void run_checks() {
  auto generator =
    choose(list_data_generator<int>
	   ({0}),
	   default_generator());

  // You can call axiom and print errors.
  catch_errors(monoid<int, op_plus, wrapped_constructor<int()> >
	       ::associativity,
	       op_plus{}, 28, 32, 58);

  // Or you can catch manually errors.
  try {
    monoid<int, op_plus, wrapped_constructor<int()> >
      ::associativity(op_plus{}, 28, 32, 58);
    monoid<int, op_plus, wrapped_constructor<int()> >
      ::identity(op_plus{}, 28, wrapped_constructor<int()>());
  } catch (axiom_failure af) {
    std::cerr << af.msg() << std::endl;
  }

  // This test will fail.
  catch_errors(monoid<int, op_times, wrapped_constructor<int()> >
	       ::identity,
	       op_times{}, 28, wrapped_constructor<int()>());

  // If data has been defined for all the types, you can
  // run them through the test driver.
  test(generator,
       monoid<int, op_plus, wrapped_constructor<int()> >
       ::associativity);
  test(generator,
       monoid<int, op_plus, wrapped_constructor<int()> >
       ::identity);

  // This one will fail.
  test(generator,
       monoid<int, op_times, wrapped_constructor<int()> >
       ::identity);

  catsfoot::check_unverified(std::cerr);
}
