// This file is a part of Catsfoot.
// Copyright (C) 2011  Uni Research
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser Public License for more details.
//
// You should have received a copy of the GNU Lesser Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <wrappers/function_wrappers.hh>
#include <list>
#include <cassert>

int main()
{
  std::list<int> l = catsfoot::constructor<std::list<int>()>()();
  std::list<int> l2 = catsfoot::constructor<std::list<int>(size_t)>()(10);
  assert(l.size() == 0);
  assert(l2.size() == 10);
  //Initialize values for Valgrind.
  for (auto i = l2.begin(); i != l2.end(); ++i) {
    *i = 0;
  }

  std::list<int> result =
    catsfoot::wrap(catsfoot::disamb<const int&>()
		     (&std::list<int>::push_back))(l, 1);
  assert(result.size() == 1);

  std::list<int> result2 = catsfoot::wrap(&std::list<int>::pop_back)(l2);
  assert(result2.size() == 9);

  int result3 = catsfoot::wrap(catsfoot::disamb_const<>()
				 (&std::list<int>::back))(l2);
  int& result4 = catsfoot::wrap(catsfoot::disamb<>()
				  (&std::list<int>::back))(l2);
  assert(result3 == l2.back());
  assert(result4 == l2.back());

  return 0;
}
